function H = QRstep(H)
% Francis QR step
n = size(H,1); 
s = H(n-1,n-1)+H(n,n);
t = H(n-1,n-1)*H(n,n)-H(n,n-1)*H(n-1,n);

% TO DO: Calculate Me_1 = [x,y,z, 0,...,0]^T 
%x = ...;
%y = ...;
%z = ...;

for k=0:n-3
  % Householder - vector
  [v,beta] = HouseholderVector([x;y;z]);
  
  % Transform for the columns
  q = max(1,k);
  H(k+1:k+3,q:n) = H(k+1:k+3,q:n) - beta*v*(v'*H(k+1:k+3,q:n));
  
  % Tranfrom for the rows
  r = min(k+4,n);
  % TO DO: update H
  % H(...,...) = ...;
  
  % Get new x,y,z (entries in H)
  x = H(k+2,k+1);
  %y = ...; % TO DO
  if k<n-3
    %z = ...; % TO DO
  end
end

% Last Householder Transform (only 2-by-2)
[v,beta] = HouseholderVector([x;y]);

% TO DO: Apply transform for columns and rows
